//rob@m0dts.co.uk 2015
//www.m0dts.co.uk

module moduletest (
	input CLOCK_50,	//Input 50MHz
	input ADC_DOUT,	//read_adc
	output ADC_DIN,	//read_adc
	output ADC_CS,		//read_adc
	output ADC_SCLK,	//read_adc
	output [7:0] leds,
	output [7:0] dac,	//output to r2r dac
	input button1,
	input button2
);



wire [0:0] sclk,slo_clk;
wire [0:0] ddsclk,outclk;
wire [7:0] I,Q,adcval,ddcI,ddcQ,ssbI,ssbQ,ssbout;

reg [7:0] dac_val;
reg [31:0] div,div2;


assign leds = -I;
assign ADC_SCLK = sclk;
assign dac = dac_val;//ddcI+8'b01111111;


clk_divN clk_divN_1 (CLOCK_50,16,sclk);	//div16, toggle on one clock edge only 3.125MHz
clk_divN clk_divN_2 (sclk,16,ddsclk);		//16 cycles to read in sample so /16
clk_divN clk_divN_3 (ddsclk,8,outclk);
read_adc read_adc_1 (sclk,ADC_DOUT,ADC_DIN,ADC_CS, adcval);

dds dds_1 (ddsclk,div,I,Q);		//21500hz


ddc ddc_1 (ddsclk,adcval,I,Q,ddcI,ddcQ); //OK

dds dds_2 (outclk,div2,ssbI,ssbQ);		//1500hz
ssbdemod ssbdemod_1 (outclk,ssbI,ssbQ,ddcI,ddcQ,ssbout);

always @*
begin
	div=65970698;//151.5khz
	div2=263883466;
end

always @ (posedge outclk)
	dac_val <= ssbout+8'b01111111;

	
endmodule
